// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "vertexVersionSimple.h"

#include "uniformWorldConstants.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"

attribute mediump vec4 POSITION;
attribute vec4 COLOR;

varying float fog;
varying mediump vec3 worldPos;

const float fogNear = 0.3;

void main() {
    vec4 planePos = POSITION;
    planePos.y -= length(planePos.xz) * 0.15;
    gl_Position = WORLDVIEWPROJ * planePos;

    fog = COLOR.r;
    worldPos = POSITION.xyz;
}