// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "fragmentVersionCentroid.h"

#ifdef GL_FRAGMENT_PRECISION_HIGH
    #define hmp highp
#else
    #define hmp mediump
#endif

#if __VERSION__ >= 300

#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
_centroid in highp vec2 uv;
#else
_centroid in vec2 uv;
#endif

#else

varying vec2 uv;

#endif

#include "uniformShaderConstants.h"
#include "util.h"

varying hmp vec3 localPos;

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;

uniform vec4 FOG_COLOR;

float drawTheSun(vec2 inPos){
   return inversesqrt(inPos.x * inPos.x + inPos.y * inPos.y);   
}

void main() {
float rain = CURRENT_COLOR.a;
float brightness = FOG_COLOR.r + FOG_COLOR.g + FOG_COLOR.b;
vec4 diffuse;

float halo = 1.0 - clamp(dot(localPos * 10.0, localPos * 10.0 / 50.0), 0.0, 1.0);
if (texture2D(TEXTURE_0, vec2(0.5, 0.5)).r > 0.1) {
    diffuse = 2.0 * mix(vec4(1.1, 1.1, 1.1, 1.0), vec4(1.5, 0.5, 0.1, 1.0), brightness * 0.35) * drawTheSun(localPos.xz * 200.0) * rain;
} else {
    diffuse = texture2D(TEXTURE_0, uv);
}
diffuse += 0.3 * mix(vec4(1.1, 1.1, 1.1, 1.0), vec4(2.75, 1.5, 0.1, 0.2), brightness * 0.35) * halo * halo * halo * halo * halo * rain;

	gl_FragColor = diffuse;
}
