#include "ShaderConstants.fxh"
#include "Util.fxh"

struct PS_Input {
    float4 position : SV_Position;
	float3 localPos : localPos;
    float2 uv : TEXCOORD_0_FB_MSAA;
};

struct PS_Output {
    float4 color : SV_Target;
};

float drawTheSun(float2 inPos){
   return rsqrt(inPos.x * inPos.x + inPos.y * inPos.y);   
}

void main(in PS_Input PSInput, out PS_Output PSOutput) {
float rain = CURRENT_COLOR.a;
float brightness = FOG_COLOR.r + FOG_COLOR.g + FOG_COLOR.b;
float4 diffuse;

float halo = 1.0 - clamp(dot(PSInput.localPos * 10.0, PSInput.localPos * 10.0 / 50.0), 0.0, 1.0);
if (TEXTURE_0.Sample(TextureSampler0, float2(0.5, 0.5)).r > 0.1) {
    diffuse = 2.0 * lerp(float4(1.1, 1.1, 1.1, 1.0), float4(1.5, 0.5, 0.1, 1.0), brightness * 0.35) * drawTheSun(PSInput.localPos.xz * 200.0) * rain;
} else {
    diffuse = TEXTURE_0.Sample(TextureSampler0, PSInput.uv);
}
diffuse += 0.3 * lerp(float4(1.1, 1.1, 1.1, 1.0), float4(2.75, 1.5, 0.1, 0.2), brightness * 0.35) * halo * halo * halo * halo * halo * rain;

	PSOutput.color = diffuse;
}