#include "ShaderConstants.fxh"

struct VS_Input {
    float3 position : POSITION;
    float2 uv : TEXCOORD_0;
#ifdef INSTANCEDSTEREO
	uint instanceID : SV_InstanceID;
#endif
};

struct PS_Input {
    float4 position : SV_Position;
	float3 localPos : localPos;
    float2 uv : TEXCOORD_0;
#ifdef INSTANCEDSTEREO
	uint instanceID : SV_InstanceID;
#endif
};

void main(in VS_Input VSInput, out PS_Input PSInput) {
PSInput.uv = VSInput.uv;
float4 verPos = float4(VSInput.position, 1) * float2(2.0, 1.0).xyxy;
#ifdef INSTANCEDSTEREO
	int i = VSInput.instanceID;
	PSInput.position = mul( WORLDVIEWPROJ_STEREO[i], verPos );
	PSInput.instanceID = i;
#else
	PSInput.position = mul(WORLDVIEWPROJ, verPos);
#endif
PSInput.localPos = VSInput.position;
}